//
//  SNGPayEachTimeVC.swift
//  Nextgen Dev
//
//  Created by Vu on 03/02/2021.
//  Copyright © 2021 Chinh.nd. All rights reserved.
//

import UIKit
protocol SNGPayEachTimeReciveData {
    func loadDataFromTemplate(data: SNGBeneficiaryModel)
}
class SNGPayEachTimeVC: SNGBaseViewController {
    @IBOutlet weak var header: SNGHead!
    @IBOutlet weak var billTypeView: SNGSelectionView!
    @IBOutlet weak var providerView: SNGSelectionView!
    @IBOutlet weak var tfCustomerID: UITextField!
    @IBOutlet weak var btnBillQueries: SNGButton!
    @IBOutlet weak var stackView: UIStackView!
    @IBOutlet weak var stackViewTopConstraint: NSLayoutConstraint!
    
    private let vCity = SNGSelectionView()
    private let viewModelCommon = SNGCommonModel()
    var selectedBillType: Int = -1
    var selectedProviders: Int = -1
    var selectedCity: Int = -1
    private let viewModelBill: SNGBillVM = SNGBillVM()
    var listBillType: [SNGBillTypeModel] = []
    var listProviders: [SNGProviderModel] = []
    var listCitys: [SNGComboboxModel] = []
    override func viewDidLoad() {
        super.viewDidLoad()
        configView()
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(true)
        loadData()
        viewModelCommon.getListCity()
    }
    
    func configView() {
        header.selectBack = {
            self.backViewController()
        }
        header.lbTitle.text = "payment.header.payeachtime".localized()
        btnBillQueries.setDisable()
        viewModelBill.getBillType()
        
        self.billTypeView.changeValue = { [weak self] in
            guard let `self` = self else {
                return
            }
            self.view.endEditing(true)
            let bottomsheet =  SNGPopupSelectionBottom()
            bottomsheet.headerTitle = "payment.label.detail.billtype".localized()
            bottomsheet.data = self.listBillType
            bottomsheet.selectedIndex = self.selectedBillType
            bottomsheet.onSelectedIndex = self.onSelectedBillType
            bottomsheet.columnType = "SNGTransferTypeViewCell"
            bottomsheet.typeModel = .SNGPayEachTimeVCBillType
            bottomsheet.modalPresentationStyle = .overCurrentContext
            bottomsheet.modalTransitionStyle = .crossDissolve
            self.present(bottomsheet, animated: true, completion: nil)
        }
        self.providerView.changeValue = {[weak self] in
            guard let `self` = self else {
                return
            }
            self.view.endEditing(true)
            let bottomsheet =  SNGPopupSelectionBottom()
            bottomsheet.headerTitle = "payment.label.detail.providers".localized()
            bottomsheet.data = self.listProviders
            bottomsheet.selectedIndex = self.selectedProviders
            bottomsheet.onSelectedIndex = self.onSelectedProviders
            bottomsheet.columnType = "SNGTransferTypeViewCell"
            bottomsheet.typeModel = .SNGPayEachTimeVCProviders
            bottomsheet.modalPresentationStyle = .overCurrentContext
            bottomsheet.modalTransitionStyle = .crossDissolve
            self.present(bottomsheet, animated: true, completion: nil)
        }
        self.vCity.lbTitle.text = "Chọn tỉnh/Thành phố"
        self.vCity.txtSelectedValue.placeholder =  "Chọn tỉnh/Thành phố"
        self.vCity.changeValue = {[weak self] in
            guard let `self` = self else {
                return
            }
            self.view.endEditing(true)
            let bottomsheet =  SNGPopupSelectionBottom()
            bottomsheet.headerTitle = "payment.label.detail.providers".localized()
            bottomsheet.data = self.listCitys
            bottomsheet.selectedIndex = self.selectedCity
            bottomsheet.onSelectedIndex = self.onSelectedCitys
            bottomsheet.columnType = "SNGTransferTypeViewCell"
            bottomsheet.typeModel = .None
            bottomsheet.modalPresentationStyle = .overCurrentContext
            bottomsheet.modalTransitionStyle = .crossDissolve
            self.present(bottomsheet, animated: true, completion: nil)
        }
    }
    func loadData() {
        viewModelBill.completionSuccess = { [weak self] message in
            guard let `self` = self else { return }
            DispatchQueue.main.async { [weak self] in
                guard let `self` = self else {return}
                if message == "BILLTYPE_SUCCESS" {
                    self.listBillType = self.viewModelBill.listBillType
                } else if message == "PROVIDERS_SUCCESS" {
                    self.listProviders = self.viewModelBill.listProviders
                    if let index = self.viewModelBill.listProviders.firstIndex(where: { $0.name_vi == self.providerView.txtSelectedValue.text }) {
                        self.selectedProviders = index
                    }
                }
                if message == "BILLING_SUCCESS" {
                    let storyboard = UIStoryboard(name: "SNGPayEachTimeDetail", bundle: nil)
                    let viewController = storyboard.instantiateViewController(withIdentifier: "SNGPayEachTimeDetail") as! SNGPayEachTimeDetailVC
                    viewController.BillId = self.tfCustomerID.text!
                    viewController.BillType = self.listBillType[self.selectedBillType]
                    viewController.Providers = self.listProviders[self.selectedProviders]
                    viewController.BillDetail = self.viewModelBill.billData
                    if self.selectedCity != -1 {
                        viewController.city = self.listCitys[self.selectedCity].text
                    }
                    self.navigationController?.pushViewController(viewController, animated: true)
                }
            }
        }
        viewModelBill.completionFailed = { [weak self] message in
            guard let `self` = self else { return }
            DispatchQueue.main.async { [weak self] in
                guard let `self` = self else {return}
                self.showError(error: message)
            }
        }
        viewModelCommon.completionSuccess = { [weak self] message in
            guard let `self` = self else { return }
            DispatchQueue.main.async { [weak self] in
                guard let `self` = self else {return}
                if message == "CITY_SUCCESS" {
                for city in self.viewModelCommon.listCity {
                    self.listCitys.append(SNGComboboxModel(id: city.cityID, text: city.cityName))
                }
            }
            }
        }
        viewModelCommon.completionFailed = { [weak self] message in
            guard let `self` = self else { return }
            DispatchQueue.main.async { [weak self] in
                guard let `self` = self else {return}
                self.showError(error: message)
            }
        }
    }
    
    
    func onSelectedBillType(index: Int){
        self.selectedBillType = index
        self.billTypeView.txtSelectedValue.text = listBillType[index].addNameVI
        viewModelBill.getProviders(serviceID: listBillType[index].serviceID)
        self.providerView.txtSelectedValue.text = ""
        vCity.removeFromSuperview()
        stackViewTopConstraint.constant = 0
        selectedProviders = -1
        validateForm()
    }
    
    func onSelectedProviders(index: Int){
        self.selectedProviders = index
        self.providerView.txtSelectedValue.text = listProviders[index].name_vi
        if listProviders[index].providerID == "VNPT" {
            stackView.addArrangedSubview(vCity)
            stackViewTopConstraint.constant = 16
        } else {
            vCity.removeFromSuperview()
            stackViewTopConstraint.constant = 0
        }
        validateForm()
    }
    func onSelectedCitys(index: Int){
        self.selectedCity = index
        self.vCity.txtSelectedValue.text = self.listCitys[index].text
        validateForm()
    }
    
    func validateForm(){
        if selectedProviders != -1 && selectedBillType != -1 && self.tfCustomerID.text != nil && self.tfCustomerID.text != "" {
            self.btnBillQueries.setEnable()
        } else {
            self.btnBillQueries.setDisable()
        }
    }
    
    
    @IBAction func onSelectCustomerID(_ sender: Any) {
        let storyboard = UIStoryboard(name: "SNGBenBillingList", bundle: nil)
        let viewController = storyboard.instantiateViewController(withIdentifier: "SNGBenBillingListVC") as! SNGBenBillingListVC
        viewController.delegate = self
        present(viewController, animated: true)
    }
    
    
    @IBAction func onSelectBillQueries(_ sender: Any) {
        if selectedCity == -1 {
        self.viewModelBill.getBillingInfo(billNo: self.tfCustomerID.text!.trim(), providerID: listProviders[selectedProviders].providerID, serviceID: listBillType[selectedBillType].serviceID, provinceID: "")
        } else {
            self.viewModelBill.getBillingInfo(billNo: self.tfCustomerID.text!.trim(), providerID: listProviders[selectedProviders].providerID, serviceID: listBillType[selectedBillType].serviceID, provinceID: listCitys[selectedCity].id)
        }
    }
    
}

extension SNGPayEachTimeVC: UITextFieldDelegate {
    func changeText(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String){
        if string.count != 1 {
            textField.text = (textField.text! as NSString).replacingCharacters(in:range, with: string.trim())
            DispatchQueue.main.async(execute: {
                let newPosition = textField.position(from:textField.beginningOfDocument, offset:range.location+string.trim().count)
                if newPosition != nil {
                    textField.selectedTextRange = textField.textRange(from: newPosition!, to: newPosition!)
                }
            })
        } else {
            textField.text = (textField.text! as NSString).replacingCharacters(in:range, with: string)
            DispatchQueue.main.async(execute: {
                let newPosition = textField.position(from: textField.beginningOfDocument, offset: range.location + string.count)
                if newPosition != nil {
                    textField.selectedTextRange = textField.textRange(from: newPosition!, to: newPosition!)
                }
            })
        }
    }
    
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {

        validateForm()
        return true
        
    }
}

extension SNGPayEachTimeVC: SNGPayEachTimeReciveData {
    func loadDataFromTemplate(data: SNGBeneficiaryModel) {
        viewModelBill.getProviders(serviceID: data.serviceCode)
        if let index = self.viewModelBill.listBillType.firstIndex(where: { $0.serviceID == data.serviceCode }) {
            self.selectedBillType = index
        }
        self.billTypeView.txtSelectedValue.text = data.serviceName
        self.providerView.txtSelectedValue.text = data.providerName
        self.tfCustomerID.text = data.billingNo
        vCity.removeFromSuperview()
        stackViewTopConstraint.constant = 0
        self.validateForm()
    }
}
